package com.systinet.demos.ws;

import com.systinet.demos.bank.Transfer;
import com.systinet.demos.bank.simple.TransferImpl;

import org.idoox.wasp.Context;
import org.idoox.webservice.client.WebServiceLookup;

public final class BankClient {

    public static void main( String[] args ) throws Exception {
        // lookup service
        WebServiceLookup lookup = (WebServiceLookup)Context.getInstance(Context.WEBSERVICE_LOOKUP);
        // bind to Bank
        BankProxy bank = 
        (BankProxy)lookup.lookup(
            "http://localhost:6060/Bank/", 
            BankProxy.class
        );
        String ssn = "001-0001-01";
        String[] numbers = bank.getAccountNumbers(ssn);
        System.out.println("Account #         \t\tBalance");
        System.out.println("---------------------------------------");
        for(int i=0; i<numbers.length; i++) {
            System.out.println(numbers[i]+"\t\t"+bank.getAccountBalance(ssn, numbers[i]));
        }
        System.out.println("---------------------------------------");
        System.out.println("Total:\t\t\t"+bank.getTotalAmount(ssn));
        TransferImpl transfer = new TransferImpl();
        
        transfer.accountNumber = numbers[0];
        transfer.accountNumberBeneficiary = "56178432743-132";
        transfer.amount = -59.99;
        transfer.type = "C";
        transfer.comment = "Macy's";
        transfer.commentBeneficiary = "John Smith - Macy's Cambridge Park";
        System.out.println("\nSubmitting transfer");
        System.out.println("-------------------");
        System.out.println("Amount: "+transfer.amount);
        bank.submitTransaction(ssn, transfer);
        System.out.println("\nAccount #         \t\tBalance");
        System.out.println("---------------------------------------");
        for(int i=0; i<numbers.length; i++) {
            System.out.println(numbers[i]+"\t\t"+bank.getAccountBalance(ssn, numbers[i]));
        }
        System.out.println("---------------------------------------");
        System.out.println("Total:\t\t\t"+bank.getTotalAmount(ssn));
        
    }
    
   
}